Attribute VB_Name = "Declares"
Option Explicit

Public Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Public Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Function TrimZero(RawText As String) As String
    Dim L As Long

    L = InStr(1, RawText, Chr(0))
    If L > 0 Then
        TrimZero = Left(RawText, InStr(1, RawText, Chr(0)) - 1)
    Else
        TrimZero = RawText
    End If
End Function

Public Function PHex(RawHex As String) As String
    Dim S As String, I As Integer, H As String

    For I = 1 To Len(RawHex)
        H = Hex(Asc(Mid(RawHex, I, 1)))
        If Len(H) = 1 Then H = "0" + H
        S = S + H + " "
    Next

    PHex = S
End Function

Public Function FillZero(RawText As String, DesiredLength As Long) As String
    If DesiredLength <= Len(RawText) Then
        FillZero = RawText
    Else
        FillZero = RawText + String(DesiredLength - Len(RawText), Chr(0))
    End If
End Function

Public Function AttachChecksum(mStr As String) As String
    AttachChecksum = Chr(Checksum(mStr)) + mStr
End Function

Public Function CheckChecksum(mStr As String) As Boolean
    If Checksum(Mid(mStr, 2)) = Asc(Left(mStr, 1)) Then
        CheckChecksum = True
    Else
        CheckChecksum = False
    End If

    mStr = Mid(mStr, 2)
End Function

Public Function Checksum(mStr As String) As Byte
    Dim I As Integer, B As Byte

    For I = 1 To Len(mStr)
        B = B Xor Asc(Mid(mStr, I, 1))
    Next

    Checksum = B
End Function

Public Function Cipher(mStr As String, Password As Long) As String
    Dim S As String, I As Integer

    Rnd -1
    Randomize Password

    For I = 1 To Len(mStr)
        S = S + Chr(Asc(Mid(mStr, I, 1)) Xor Int(Rnd * 256))
    Next

'    MsgBox PHex(mStr) + vbNewLine + PHex(S), vbInformation, "Cipher(" + CStr(Password) + "):"

    Cipher = S
End Function

Public Function MakeKey(Password As String) As Long
    Dim I As Integer, L As Long

    For I = 1 To 6
        L = L Xor (Asc(Mid(Password, I, 1)) * 2 ^ (I - 1))
    Next

    MakeKey = L
End Function

Public Function Pack(mStr As String) As String
    Dim S As String, A As String, C As String * 1, I As Integer

    S = Chr(Len(mStr) + 2)

    For I = 1 To Len(mStr)
        C = Mid(mStr, I, 1)

        If C = Chr(0) Then
            A = A + Chr(I + 1)
        Else
            S = S + C
        End If
    Next

'    MsgBox PHex(mStr) + vbNewLine + PHex(S + A), vbInformation, "Pack():"

    Pack = S + A
End Function

Public Function Unpack(mStr As String) As String
    Dim S As String, A As String, I As Integer

    A = Mid(mStr, Asc(Left(mStr, 1)))
    S = mStr

    For I = 1 To Len(A)
        InsertByte S, Asc(Mid(A, I, 1)), 0
    Next

'    MsgBox PHex(mStr) + vbNewLine + PHex(Mid(S, 2, Asc(Left(mStr, 1)))), vbInformation, "Unpack():"

    Unpack = Mid(S, 2, Asc(Left(mStr, 1)))
End Function

'This one actually inserts a byte, it does not replace
Public Sub InsertByte(mStr As String, Offset As Byte, NewByte As Byte)
    mStr = Left(mStr, Offset - 1) + Chr(NewByte) + Mid(mStr, Offset)
End Sub
